## restinio 0.6.6

=== dev/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

SET(CMAKE_CXX_STANDARD 14)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)

# Determine if RESTinio is built as a subproject (using add_subdirectory)
# or if it is the master project.
SET(RESTINIO_MASTER_PROJECT OFF)
IF (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
	SET(RESTINIO_MASTER_PROJECT ON)
ENDIF ()

option(RESTINIO_INSTALL "Generate the install target." ${RESTINIO_MASTER_PROJECT})
option(RESTINIO_TEST "Build the tests." ${RESTINIO_MASTER_PROJECT})
option(RESTINIO_SAMPLE "Build samples." ${RESTINIO_MASTER_PROJECT})
option(RESTINIO_INSTALL_SAMPLES "Build install samples." ${RESTINIO_MASTER_PROJECT})
option(RESTINIO_BENCH "Build the test target." ${RESTINIO_MASTER_PROJECT})
option(RESTINIO_INSTALL_BENCHES "Build install samples." ${RESTINIO_MASTER_PROJECT})
option(RESTINIO_FIND_DEPS "Use `find_package()` for including RESTinio dependencies." OFF)
option(RESTINIO_FMT_HEADER_ONLY "Include fmt library as header-only." ON)

option(RESTINIO_ALLOW_SOBJECTIZER "Allow add_subdirectory(so_5) in the main RESTinio CMakeLists.txt" ${RESTINIO_MASTER_PROJECT})

# Since v.0.6.5 a user can force usage of already installed http-parser
# library.
option(RESTINIO_USE_EXTERNAL_HTTP_PARSER "Use already installed http-parser library" OFF)

SET(RESTINIO_USE_BOOST_ASIO "none" CACHE STRING "Use boost version of ASIO")
SET(RESTINIO_USE_BOOST_ASIO_VALUES "none;static;shared")

set_property(CACHE RESTINIO_USE_BOOST_ASIO PROPERTY STRINGS ${RESTINIO_USE_BOOST_ASIO_VALUES})

IF ((RESTINIO_TEST OR RESTINIO_SAMPLE OR RESTINIO_BENCH)
		AND (NOT RESTINIO_ALLOW_SOBJECTIZER))
	message(FATAL_ERROR "RESTINIO_ALLOW_SOBJECTIZER can't be OFF if RESTINIO_TEST or RESTINIO_SAMPLE or RESTINIO_BENCH is used")
ENDIF ()

IF (RESTINIO_MASTER_PROJECT)
	# RESTinio is a main project (not subproject)
	# Do regular stuff here.

	list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
	include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/link_threads_if_necessary.cmake")

	# ------------------------------------------------------------------------------
	# RESTinio dependencies:
	# ASIO or Boost::ASIO
	IF ( RESTINIO_USE_BOOST_ASIO MATCHES "none" )
		SET( RESTINIO_STAND_ALONE_ASIO_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/asio/include )
		SET( RESTINIO_STAND_ALONE_ASIO_DEFINES -DASIO_STANDALONE -DASIO_HAS_STD_CHRONO -DASIO_DISABLE_STD_STRING_VIEW)

		# Try to find boost for boost regex.
		SET(Boost_USE_MULTITHREADED ON)
		find_package(Boost COMPONENTS regex)
		if ( Boost_FOUND )
			message(STATUS "Found Boost for regex.")
		endif ()
	ELSE ()
		SET(Boost_USE_MULTITHREADED ON)
		IF ( RESTINIO_USE_BOOST_ASIO MATCHES "shared" )
			SET(Boost_USE_STATIC_LIBS OFF)
		ELSE ()
			SET(Boost_USE_STATIC_LIBS ON)
		ENDIF ()

		find_package(Boost 1.66.0 REQUIRED COMPONENTS system regex)
	ENDIF ()

	IF (RESTINIO_FIND_DEPS)
		# Require necessary packages.

		# Catch2
		IF (RESTINIO_TEST)
			find_package(Catch2 CONFIG REQUIRED)
		ENDIF ()

		# HTTP parser
		IF (RESTINIO_USE_EXTERNAL_HTTP_PARSER)
			find_package(http-parser REQUIRED)
		ELSE ()
			find_package(unofficial-http-parser CONFIG REQUIRED)
		ENDIF ()

		# fmtlib
		find_package(fmt REQUIRED)
	ELSE ()
		# Add necessary dependecies.

		include_directories("${CMAKE_SOURCE_DIR}/clara")

		# HTTP parser
		IF (RESTINIO_USE_EXTERNAL_HTTP_PARSER)
			find_package(http-parser REQUIRED)
		ELSE ()
			add_subdirectory(nodejs/http_parser)
		ENDIF ()

		# fmtlib
		add_subdirectory(fmt)
	ENDIF ()

	# ------------------------------------------------------------------------------

	# ------------------------------------------------------------------------------
	# Tests, samples and benchmark dependencies:
	# OpenSSL
	find_package(OpenSSL)
	IF ( OPENSSL_FOUND )
		message("OpenSSL include dir: ${OPENSSL_INCLUDE_DIR}")
		message("OpenSSL libraries: ${OPENSSL_LIBRARIES}")
	ENDIF ( OPENSSL_FOUND )

	# PCRE
	find_package(PCRE)
	IF (PCRE_FOUND)
		message( STATUS "PCRE_LIBRARIES='" ${PCRE_LIBRARIES} "'" )
		message( STATUS "PCRE_INCLUDE_DIRS='" ${PCRE_INCLUDE_DIRS} "'" )
	ENDIF ()

	# PCRE2
	find_package(PCRE2)
	IF (PCRE2_FOUND)
		message( STATUS "PCRE2_LIBRARIES='" ${PCRE2_LIBRARIES} "'" )
		message( STATUS "PCRE2_INCLUDE_DIRS='" ${PCRE2_INCLUDE_DIRS} "'" )
	ENDIF ()

	# PCRE2
	find_package(PCRE2)
	IF (PCRE2_FOUND)
		message( STATUS "PCRE2_LIBRARIES='" ${PCRE2_LIBRARIES} "'" )
		message( STATUS "PCRE2_INCLUDE_DIRS='" ${PCRE2_INCLUDE_DIRS} "'" )
	ENDIF ()

	# ------------------------------------------------------------------------------
	# SObjectizer
	IF (RESTINIO_ALLOW_SOBJECTIZER)
		SET(SOBJECTIZER_BUILD_STATIC ON)
		SET(SOBJECTIZER_LIBS sobjectizer::StaticLib)
		add_subdirectory(so_5)
	ENDIF ()

	# ------------------------------------------------------------------------------
	# Zlib
	find_package(ZLIB)

	IF (NOT ZLIB_FOUND)
		add_subdirectory(restinio/third_party/zlib)
		message( STATUS "USE OWN ZLIB SOURCES")
		SET(ZLIB_LIBRARIES zlibstatic)
		SET(ZLIB_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/restinio/third_party/zlib)
	ENDIF ()

	message( STATUS "ZLIB_LIBRARIES='" ${ZLIB_LIBRARIES} "'" )
	message( STATUS "ZLIB_INCLUDE_DIRS='" ${ZLIB_INCLUDE_DIRS} "'" )
ENDIF (RESTINIO_MASTER_PROJECT)

# RESTinio itself.
add_subdirectory(restinio)

# ------------------------------------------------------------------------------
# Tests
IF (RESTINIO_TEST)
	enable_testing()
	add_subdirectory(test)

	IF (WIN32)
		configure_file(${CMAKE_SOURCE_DIR}/cmake/run_tests.bat ${CMAKE_BINARY_DIR} NEWLINE_STYLE WIN32)
	ENDIF ()
ENDIF ()

# ------------------------------------------------------------------------------
# Samples
IF (RESTINIO_SAMPLE)
	add_subdirectory(sample)
ENDIF ()

# ------------------------------------------------------------------------------
# Benches
IF (RESTINIO_BENCH)
	add_subdirectory(benches)
ENDIF ()

=== dev/restinio/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

SET(RESTINIO restinio)

include(cmake/target.cmake)

project(${RESTINIO}) # not to misspell it.

add_library(${RESTINIO} INTERFACE)
add_library(restinio::restinio ALIAS ${RESTINIO})

IF (${CMAKE_VERSION} VERSION_LESS "3.8.0")
	set(CMAKE_CXX_STANDARD 14)
	set(CMAKE_CXX_STANDARD_REQUIRED ON)
	set(CMAKE_CXX_EXTENSIONS OFF)
ELSE ()
	target_compile_features(${RESTINIO} INTERFACE cxx_std_14)
ENDIF ()

get_filename_component(CURRENT_FILE_DIR ${CMAKE_CURRENT_LIST_FILE} DIRECTORY)
get_filename_component(CURRENT_FILE_DIR ${CURRENT_FILE_DIR} DIRECTORY)
SET(RESTINIO_INCLUDE_PATH ${CURRENT_FILE_DIR})
UNSET(CURRENT_FILE_DIR)

# Propagate include directories for RESTinio.
TARGET_INCLUDE_DIRECTORIES(${RESTINIO}
	INTERFACE
		$<BUILD_INTERFACE:${RESTINIO_INCLUDE_PATH}>
		$<INSTALL_INTERFACE:include>
	)

# ------------------------------------------------------------------------------
# ASIO or Boost::ASIO
IF ( RESTINIO_USE_BOOST_ASIO MATCHES "none" )
	IF (RESTINIO_STAND_ALONE_ASIO_HEADERS)
		TARGET_INCLUDE_DIRECTORIES(${RESTINIO} INTERFACE
			$<BUILD_INTERFACE:${RESTINIO_STAND_ALONE_ASIO_HEADERS}>)
	ENDIF ()

	IF( RESTINIO_STAND_ALONE_ASIO_DEFINES )
		TARGET_COMPILE_DEFINITIONS(${RESTINIO} INTERFACE ${RESTINIO_STAND_ALONE_ASIO_DEFINES})
	ENDIF ()

ELSE ()
	TARGET_INCLUDE_DIRECTORIES(${RESTINIO} INTERFACE ${Boost_INCLUDE_DIRS} )
	TARGET_COMPILE_DEFINITIONS(${RESTINIO} INTERFACE -DRESTINIO_USE_BOOST_ASIO )
ENDIF ()
# ------------------------------------------------------------------------------

IF (RESTINIO_FIND_DEPS)
	message(STATUS "RESTinio dependencies are included with `find_package()`")

	IF (RESTINIO_FMT_HEADER_ONLY)
		TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE fmt::fmt-header-only)
	ELSE ()
		TARGET_LINK_LIBRARIES(${RESTINIO} PUBLIC fmt::fmt)
	ENDIF ()

	IF (RESTINIO_USE_EXTERNAL_HTTP_PARSER)
		TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE http_parser)
	ELSE ()
		TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE unofficial::http_parser::http_parser)
	ENDIF ()
ELSE ()
	IF (RESTINIO_FMT_HEADER_ONLY)
		TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE $<BUILD_INTERFACE:fmt::fmt-header-only>)
	ELSE ()
		TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE $<BUILD_INTERFACE:fmt::fmt>)
	ENDIF ()

	IF (RESTINIO_USE_EXTERNAL_HTTP_PARSER)
		TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE $<BUILD_INTERFACE:http_parser>)
	ELSE ()
		TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE $<BUILD_INTERFACE:unofficial::http_parser::http_parser>)
	ENDIF ()
ENDIF ()

IF ( NOT (RESTINIO_USE_BOOST_ASIO STREQUAL "none") )
	TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE ${Boost_SYSTEM_LIBRARY} )
ENDIF ()

FILE(GLOB_RECURSE RESTINIO_HEADERS_ALL RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.?pp)

IF (RESTINIO_INSTALL)
	include(GNUInstallDirs)
	include(CMakePackageConfigHelpers)

	SET(RESTINIO_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/restinio CACHE STRING
		"Installation directory for cmake files, relative to ${CMAKE_INSTALL_PREFIX}.")
	SET(RESTINIO_VERSION_CONFIG ${PROJECT_BINARY_DIR}/restinio-config-version.cmake)
	SET(RESTINIO_PROJECT_CONFIG ${PROJECT_BINARY_DIR}/restinio-config.cmake)

	SET(RESTINIO_INC_DIR ${CMAKE_INSTALL_INCLUDEDIR}/restinio/ CACHE STRING
		"Installation directory for include files, relative to ${CMAKE_INSTALL_PREFIX}.")

	# Generate the version, config and target files into the build directory.
	write_basic_package_version_file(
		${RESTINIO_VERSION_CONFIG}
		VERSION ${RESTINIO_VERSION}
		COMPATIBILITY ExactVersion )

	configure_package_config_file(
		"cmake/restinio-config.cmake.in"
		${RESTINIO_PROJECT_CONFIG}
		INSTALL_DESTINATION ${RESTINIO_CMAKE_DIR}
		PATH_VARS RESTINIO_VERSION)

	# Install version, config and target files.
	install(
		FILES ${RESTINIO_PROJECT_CONFIG} ${RESTINIO_VERSION_CONFIG}
		DESTINATION ${RESTINIO_CMAKE_DIR})

	SET(RESTINIO_INSTALL_TARGETS ${RESTINIO})

	install(
		TARGETS ${RESTINIO_INSTALL_TARGETS}
		EXPORT RESTINIO_ALL_TARGETS
		LIBRARY DESTINATION lib
		ARCHIVE DESTINATION lib
		RUNTIME DESTINATION bin
	)

	install(
		EXPORT RESTINIO_ALL_TARGETS
		NAMESPACE restinio::
		FILE restinio-targets.cmake
		DESTINATION ${RESTINIO_CMAKE_DIR} )

	FOREACH (HEADER_FILE ${RESTINIO_HEADERS_ALL} )
		get_filename_component( DIR ${HEADER_FILE} PATH )
		install( FILES ${HEADER_FILE} DESTINATION ${RESTINIO_INC_DIR}/${DIR} )
	ENDFOREACH ()

ENDIF ()

=== dev/sample/CMakeLists.txt ===
project(sample)

add_subdirectory(hello_world_basic)
add_subdirectory(hello_world)
add_subdirectory(hello_world_minimal)
add_subdirectory(hello_world_delayed)
add_subdirectory(hello_world_sendfile)
add_subdirectory(run_existing_server)
add_subdirectory(run_for_minute)
add_subdirectory(express_router)
add_subdirectory(express_router_tutorial)
add_subdirectory(easy_parser_router)
add_subdirectory(sendfiles)
add_subdirectory(query_string_params)
add_subdirectory(try_parse_query_string)
add_subdirectory(websocket)
add_subdirectory(websocket_detailed)
add_subdirectory(using_external_io_context)
add_subdirectory(async_handling_with_sobjectizer)
add_subdirectory(compression)
add_subdirectory(decompression)
add_subdirectory(notificators)
add_subdirectory(custom_buffer)
add_subdirectory(connection_state)
add_subdirectory(ip_blocker)
add_subdirectory(file_upload)

if ( OPENSSL_FOUND )
	add_subdirectory(hello_world_https)
	add_subdirectory(hello_world_sendfile_https)
	add_subdirectory(websocket_wss)
	add_subdirectory(tls_inspector)
endif ()

if( WIN32 )
	add_subdirectory(hello_world_sendfile_w32_unicode)
endif()

=== dev/test/http_field_parser/CMakeLists.txt ===
set(UNITTEST _unit.test.http_field_parser)
set(UNITTEST_SRCFILES
	basics.cpp
	media-type.cpp
	content-type.cpp
	cache-control.cpp
	content-encoding.cpp
	accept.cpp
	accept-charset.cpp
	accept-encoding.cpp
	accept-language.cpp
	content-disposition.cpp
	range.cpp
	user-agent.cpp
)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== debian/changelog ===
restinio (0.6.6-1) unstable; urgency=medium

  [ Sébastien Delafond ]
  * Build-depend on cmake
  * Add debian/watch
  * Clean up d/rules
  * Enable tests and samples, with extra build-depends
  * New upstream version 0.6.6
  * Add basic d/salsa-ci.yml

 -- Sebastien Delafond <seb@debian.org>  Thu, 07 May 2020 15:51:22 +0200

restinio (0.6.4-1) UNRELEASED; urgency=medium

  * Initial release (Closes: #946832)
  * TODO: why does it have build depends,
          possible cmake ma{gic,dness}?

 -- Felix Salfelder <felix@salfelder.org>  Sun, 16 Feb 2020 19:07:44 +0000

=== debian/control ===
Source: restinio
Priority: optional
Maintainer: Felix Salfelder <felix@salfelder.org>
Build-Depends: debhelper-compat (= 12),
  libasio-dev, 
  libfmt-dev,
  cmake,
  libboost-dev,
  libboost-regex-dev,
  libssl-dev,
  zlib1g-dev,
  libpcre2-dev,
  libhttp-parser-dev,
  libpcre++-dev,
  catch2
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/Stiffstream/restinio
Vcs-Browser: https://salsa.debian.org/debian/restinio
Vcs-Git: https://salsa.debian.org/debian/restinio.git
Rules-Requires-Root: no

Package: librestinio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Description: restinio implements an embedded HTTP/Websocket server
 It is based on standalone version of ASIO and targeted primarily for
 asynchronous processing of HTTP-requests.
 Since v.0.4.1 Boost::ASIO (1.66 or higher) is also supported
 This package contains a header-only C++14 library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
# export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CMAKE_OPTIONS := -DRESTINIO_FIND_DEPS=1 \
                 -DRESTINIO_USE_EXTERNAL_HTTP_PARSER=1 \
                 -DRESTINIO_FMT_HEADER_ONLY=0 \
                 -DRESTINIO_ALLOW_SOBJECTIZER=1 \
	         -DRESTINIO_TEST=1 \
                 -DRESTINIO_SAMPLE=1 \
                 -DRESTINIO_BENCH=1 \
                 -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)"

%:
	dh $@ --sourcedirectory=dev

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=dev -- $(CMAKE_OPTIONS)

override_dh_auto_test:
	export DEB_BUILD_OPTIONS="parallel=1" ; dh_auto_test

override_dh_auto_install:
	dh_auto_install
	rm -fr debian/librestinio-dev/usr/bin

## restinio 0.6.13

=== dev/json_dto/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

SET(JSON_DTO json-dto)

include(cmake/target.cmake)

project(${JSON_DTO}) # not to misspell it.

add_library(${JSON_DTO} INTERFACE)
add_library(json-dto::json-dto ALIAS ${JSON_DTO})

IF (${CMAKE_VERSION} VERSION_LESS "3.8.0")
	set(CMAKE_CXX_STANDARD 14)
	set(CMAKE_CXX_STANDARD_REQUIRED ON)
	set(CMAKE_CXX_EXTENSIONS OFF)
ELSE ()
	target_compile_features(${JSON_DTO} INTERFACE cxx_std_14)
ENDIF ()

get_filename_component(CURRENT_FILE_DIR ${CMAKE_CURRENT_LIST_FILE} DIRECTORY)
get_filename_component(CURRENT_FILE_DIR ${CURRENT_FILE_DIR} DIRECTORY)
SET(JSON_DTO_INCLUDE_PATH ${CURRENT_FILE_DIR})
UNSET(CURRENT_FILE_DIR)

IF (JSON_DTO_FIND_DEPS)
	TARGET_INCLUDE_DIRECTORIES( ${JSON_DTO} INTERFACE ${RAPIDJSON_INCLUDE_DIRS} )
ENDIF ()

# Propagate include directories for json_dto.
TARGET_INCLUDE_DIRECTORIES(${JSON_DTO}
	INTERFACE
		$<BUILD_INTERFACE:${JSON_DTO_INCLUDE_PATH}>
		$<INSTALL_INTERFACE:include>
	)

TARGET_COMPILE_DEFINITIONS(${JSON_DTO} INTERFACE
	-DRAPIDJSON_HAS_STDSTRING=1
	-DRAPIDJSON_HAS_CXX11_RVALUE_REFS=1)

SET(JSON_DTO_HEADERS_ALL
	pub.hpp
	validators.hpp )

IF (JSON_DTO_INSTALL)
	include(GNUInstallDirs)
	include(CMakePackageConfigHelpers)

	SET(JSON_DTO_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/json-dto CACHE STRING
		"Installation directory for cmake files, relative to ${CMAKE_INSTALL_PREFIX}.")
	SET(JSON_DTO_VERSION_CONFIG ${PROJECT_BINARY_DIR}/json-dto-config-version.cmake)
	SET(JSON_DTO_PROJECT_CONFIG ${PROJECT_BINARY_DIR}/json-dto-config.cmake)

	SET(JSON_DTO_INC_DIR ${CMAKE_INSTALL_INCLUDEDIR}/json_dto/ CACHE STRING
		"Installation directory for include files, relative to ${CMAKE_INSTALL_PREFIX}.")

	# Generate the version, config and target files into the build directory.
	write_basic_package_version_file(
		${JSON_DTO_VERSION_CONFIG}
		VERSION ${JSON_DTO_VERSION}
		COMPATIBILITY ExactVersion )

	configure_package_config_file(
		"cmake/json-dto-config.cmake.in"
		${JSON_DTO_PROJECT_CONFIG}
		INSTALL_DESTINATION ${JSON_DTO_CMAKE_DIR}
		PATH_VARS JSON_DTO_VERSION)

	# Install version, config and target files.
	install(
		FILES ${JSON_DTO_PROJECT_CONFIG} ${JSON_DTO_VERSION_CONFIG}
		DESTINATION ${JSON_DTO_CMAKE_DIR})

	set (JSON_DTO_INSTALL_TARGETS ${JSON_DTO})

	install(
		TARGETS ${JSON_DTO_INSTALL_TARGETS}
		EXPORT JSON_DTO_ALL_TARGETS
		LIBRARY DESTINATION lib
		ARCHIVE DESTINATION lib
		RUNTIME DESTINATION bin
	)

	install(
		EXPORT JSON_DTO_ALL_TARGETS
		NAMESPACE json-dto::
		FILE json-dto-targets.cmake
		DESTINATION ${JSON_DTO_CMAKE_DIR} )

	FOREACH(HEADER_FILE ${JSON_DTO_HEADERS_ALL} )
		get_filename_component( DIR ${HEADER_FILE} PATH )
		install( FILES ${HEADER_FILE} DESTINATION ${JSON_DTO_INC_DIR}/${DIR} )
	ENDFOREACH()

ENDIF ()

=== dev/sample/custom_buffer/CMakeLists.txt ===
set(SAMPLE sample.custom_buffer)
include(${CMAKE_SOURCE_DIR}/cmake/sample.cmake)

=== dev/sample/websocket_wss/CMakeLists.txt ===
set(SAMPLE sample.websocket_wss)
include(${CMAKE_SOURCE_DIR}/cmake/sample.cmake)

TARGET_INCLUDE_DIRECTORIES(${SAMPLE} PRIVATE ${OPENSSL_INCLUDE_DIR})
TARGET_LINK_LIBRARIES(${SAMPLE} PRIVATE ${OPENSSL_LIBRARIES})

IF (RESTINIO_INSTALL_SAMPLES)
	# Put pem files in bin dir:
	install(FILES wss_dh2048.pem wss_key.pem wss_server.pem DESTINATION bin)
ENDIF ()

=== dev/test/http_field_parser/CMakeLists.txt ===
--- 
+++ 
@@ -4,14 +4,18 @@
 	media-type.cpp
 	content-type.cpp
 	cache-control.cpp
+	connection.cpp
 	content-encoding.cpp
 	accept.cpp
 	accept-charset.cpp
 	accept-encoding.cpp
 	accept-language.cpp
+	authorization.cpp
 	content-disposition.cpp
 	range.cpp
 	user-agent.cpp
+	transfer-encoding.cpp
+	host.cpp
 )
 include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== dev/test/handle_requests/chained_handlers/CMakeLists.txt ===
set(UNITTEST _unit.test.handle_requests.chained_handlers)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== dev/test/handle_requests/incoming_msg_limits/CMakeLists.txt ===
set(UNITTEST _unit.test.handle_requests.incoming_msg_limits)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== dev/test/handle_requests/slow_transmit/CMakeLists.txt ===
set(UNITTEST _unit.test.handle_requests.slow_transmit)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== dev/test/handle_requests/timeouts/CMakeLists.txt ===
set(UNITTEST _unit.test.handle_requests.timeouts)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== debian/changelog ===
restinio (0.6.13-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.

 -- Alexandre Viau <aviau@debian.org>  Mon, 04 Jan 2021 11:26:26 -0500

restinio (0.6.6-3) unstable; urgency=medium

  * Link atomic on a few architectures (Closes: #960824)
    Thanks to Adrian Bunk.
  * Disable tests (avoid internet access).

 -- Felix Salfelder <felix@salfelder.org>  Mon, 19 Oct 2020 08:51:24 +0100

restinio (0.6.6-2) unstable; urgency=medium

  [ Felix Salfelder ]
  * add dependencies on http-parser and fmt (Closes: #968454)

 -- Sebastien Delafond <seb@debian.org>  Mon, 31 Aug 2020 09:02:31 +0200

=== debian/control ===
Source: restinio
Priority: optional
Maintainer: Felix Salfelder <felix@salfelder.org>
Build-Depends: catch2,
               cmake,
               debhelper-compat (= 12),
               libasio-dev,
               libboost-dev,
               libboost-regex-dev,
               libfmt-dev,
               libhttp-parser-dev,
               libpcre++-dev,
               libpcre2-dev,
               libssl-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/Stiffstream/restinio
Vcs-Browser: https://salsa.debian.org/debian/restinio
Vcs-Git: https://salsa.debian.org/debian/restinio.git
Rules-Requires-Root: no

Package: librestinio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfmt-dev, libhttp-parser-dev, ${misc:Depends}
Description: restinio implements an embedded HTTP/Websocket server
 It is based on standalone version of ASIO and targeted primarily for
 asynchronous processing of HTTP-requests.
 Since v.0.4.1 Boost::ASIO (1.66 or higher) is also supported
 This package contains a header-only C++14 library.

=== debian/rules ===
--- 
+++ 
@@ -14,11 +14,15 @@
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
+ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc sh4))
+	export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
+endif
+
 CMAKE_OPTIONS := -DRESTINIO_FIND_DEPS=1 \
                  -DRESTINIO_USE_EXTERNAL_HTTP_PARSER=1 \
                  -DRESTINIO_FMT_HEADER_ONLY=0 \
                  -DRESTINIO_ALLOW_SOBJECTIZER=1 \
-	         -DRESTINIO_TEST=1 \
+                 -DRESTINIO_TEST=1 \
                  -DRESTINIO_SAMPLE=1 \
                  -DRESTINIO_BENCH=1 \
                  -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)"
@@ -30,7 +34,7 @@
 	dh_auto_configure --sourcedirectory=dev -- $(CMAKE_OPTIONS)
 
 override_dh_auto_test:
-	export DEB_BUILD_OPTIONS="parallel=1" ; dh_auto_test
+	: # export DEB_BUILD_OPTIONS="parallel=1" ; dh_auto_test
 
 override_dh_auto_install:
 	dh_auto_install

=== debian/watch ===
version=4
https://github.com/Stiffstream/restinio/releases (?:.*?/)restinio-(\d[\d.]*)-full\.tar\.bz2 debian uupdate

## restinio 0.6.13-1%2B10.0trisquel1

=== dev/restinio/CMakeLists.txt ===
--- 
+++ 
@@ -53,7 +53,7 @@
 	IF (RESTINIO_FMT_HEADER_ONLY)
 		TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE fmt::fmt-header-only)
 	ELSE ()
-		TARGET_LINK_LIBRARIES(${RESTINIO} PUBLIC fmt::fmt)
+		TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE fmt::fmt)
 	ENDIF ()
 
 	IF (RESTINIO_USE_EXTERNAL_HTTP_PARSER)
@@ -75,11 +75,53 @@
 	ENDIF ()
 ENDIF ()
 
+IF (RESTINIO_USE_EXTERNAL_EXPECTED_LITE)
+	TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE nonstd::expected-lite)
+	TARGET_COMPILE_DEFINITIONS(${RESTINIO}
+		INTERFACE -DRESTINIO_EXTERNAL_EXPECTED_LITE)
+ENDIF()
+
+IF (RESTINIO_USE_EXTERNAL_OPTIONAL_LITE)
+	TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE nonstd::optional-lite)
+	TARGET_COMPILE_DEFINITIONS(${RESTINIO}
+		INTERFACE -DRESTINIO_EXTERNAL_OPTIONAL_LITE)
+ENDIF()
+
+IF (RESTINIO_USE_EXTERNAL_STRING_VIEW_LITE)
+	TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE nonstd::string-view-lite)
+	TARGET_COMPILE_DEFINITIONS(${RESTINIO}
+		INTERFACE -DRESTINIO_EXTERNAL_STRING_VIEW_LITE)
+ENDIF()
+
+IF (RESTINIO_USE_EXTERNAL_VARIANT_LITE)
+	TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE nonstd::variant-lite)
+	TARGET_COMPILE_DEFINITIONS(${RESTINIO}
+		INTERFACE -DRESTINIO_EXTERNAL_VARIANT_LITE)
+ENDIF()
+
 IF ( NOT (RESTINIO_USE_BOOST_ASIO STREQUAL "none") )
 	TARGET_LINK_LIBRARIES(${RESTINIO} INTERFACE ${Boost_SYSTEM_LIBRARY} )
 ENDIF ()
 
 FILE(GLOB_RECURSE RESTINIO_HEADERS_ALL RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.?pp)
+
+# If *_lite library is used as external dependency then the corresponding
+# 3rd-party file should be removed.
+IF (RESTINIO_USE_EXTERNAL_EXPECTED_LITE)
+	list(REMOVE_ITEM RESTINIO_HEADERS_ALL third_party/expected-lite/expected.hpp)
+ENDIF()
+
+IF (RESTINIO_USE_EXTERNAL_OPTIONAL_LITE)
+	list(REMOVE_ITEM RESTINIO_HEADERS_ALL third_party/optional-lite/optional.hpp)
+ENDIF()
+
+IF (RESTINIO_USE_EXTERNAL_STRING_VIEW_LITE)
+	list(REMOVE_ITEM RESTINIO_HEADERS_ALL third_party/string-view-lite/string_view.hpp)
+ENDIF()
+
+IF (RESTINIO_USE_EXTERNAL_VARIANT_LITE)
+	list(REMOVE_ITEM RESTINIO_HEADERS_ALL third_party/variant-lite/variant.hpp)
+ENDIF()
 
 IF (RESTINIO_INSTALL)
 	include(GNUInstallDirs)

=== debian/changelog ===
restinio (0.6.13-1+10.0trisquel1) nabia; urgency=medium

  * Backported from Hirsute

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 29 Sep 2021 10:34:48 +0000

## restinio 0.6.13-1+10.0trisquel1

=== dev/CMakeLists.txt ===
--- 
+++ 
@@ -19,21 +19,39 @@
 option(RESTINIO_FIND_DEPS "Use `find_package()` for including RESTinio dependencies." OFF)
 option(RESTINIO_FMT_HEADER_ONLY "Include fmt library as header-only." ON)
 
-option(RESTINIO_ALLOW_SOBJECTIZER "Allow add_subdirectory(so_5) in the main RESTinio CMakeLists.txt" ${RESTINIO_MASTER_PROJECT})
+option(RESTINIO_ALLOW_SOBJECTIZER "Allow usage of SObjectizer" ${RESTINIO_MASTER_PROJECT})
+
+option(RESTINIO_USE_EXTERNAL_SOBJECTIZER "Allow add_subdirectory(so_5) in the main RESTinio CMakeLists.txt" OFF)
 
 # Since v.0.6.5 a user can force usage of already installed http-parser
 # library.
 option(RESTINIO_USE_EXTERNAL_HTTP_PARSER "Use already installed http-parser library" OFF)
 
+# Since v.0.6.7 a user can force usage of already installed nonstd
+# libraries.
+option(RESTINIO_USE_EXTERNAL_EXPECTED_LITE
+	"Use already installed expected-lite library" OFF)
+option(RESTINIO_USE_EXTERNAL_OPTIONAL_LITE
+	"Use already installed optional-lite library" OFF)
+option(RESTINIO_USE_EXTERNAL_STRING_VIEW_LITE
+	"Use already installed string-view-lite library" OFF)
+option(RESTINIO_USE_EXTERNAL_VARIANT_LITE
+	"Use already installed variant-lite library" OFF)
+
 SET(RESTINIO_USE_BOOST_ASIO "none" CACHE STRING "Use boost version of ASIO")
 SET(RESTINIO_USE_BOOST_ASIO_VALUES "none;static;shared")
 
 set_property(CACHE RESTINIO_USE_BOOST_ASIO PROPERTY STRINGS ${RESTINIO_USE_BOOST_ASIO_VALUES})
 
-IF ((RESTINIO_TEST OR RESTINIO_SAMPLE OR RESTINIO_BENCH)
-		AND (NOT RESTINIO_ALLOW_SOBJECTIZER))
-	message(FATAL_ERROR "RESTINIO_ALLOW_SOBJECTIZER can't be OFF if RESTINIO_TEST or RESTINIO_SAMPLE or RESTINIO_BENCH is used")
-ENDIF ()
+project(RESTinioRootProject CXX)
+
+IF (RESTINIO_USE_EXTERNAL_SOBJECTIZER AND NOT RESTINIO_ALLOW_SOBJECTIZER)
+	message(FATAL_ERROR "RESTINIO_USE_EXTERNAL_SOBJECTIZER can't be set without RESTINIO_ALLOW_SOBJECTIZER")
+ENDIF()
+
+IF (RESTINIO_ALLOW_SOBJECTIZER)
+	SET(RESTINIO_SOBJECTIZER_ENABLED ON)
+ENDIF()
 
 IF (RESTINIO_MASTER_PROJECT)
 	# RESTinio is a main project (not subproject)
@@ -41,6 +59,7 @@
 
 	list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
 	include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/link_threads_if_necessary.cmake")
+	include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/link_atomic_if_necessary.cmake")
 
 	# ------------------------------------------------------------------------------
 	# RESTinio dependencies:
@@ -74,6 +93,8 @@
 			find_package(Catch2 CONFIG REQUIRED)
 		ENDIF ()
 
+		include_directories("${CMAKE_SOURCE_DIR}/clara")
+
 		# HTTP parser
 		IF (RESTINIO_USE_EXTERNAL_HTTP_PARSER)
 			find_package(http-parser REQUIRED)
@@ -98,6 +119,21 @@
 		# fmtlib
 		add_subdirectory(fmt)
 	ENDIF ()
+
+	# If RESTINIO_USE_EXTERNAL_*_LITE is defined we should
+	# search that libs regardless of RESTINIO_FIND_DEPS option.
+	IF (RESTINIO_USE_EXTERNAL_EXPECTED_LITE)
+		find_package(expected-lite REQUIRED)
+	ENDIF()
+	IF (RESTINIO_USE_EXTERNAL_OPTIONAL_LITE)
+		find_package(optional-lite REQUIRED)
+	ENDIF()
+	IF (RESTINIO_USE_EXTERNAL_STRING_VIEW_LITE)
+		find_package(string-view-lite REQUIRED)
+	ENDIF()
+	IF (RESTINIO_USE_EXTERNAL_VARIANT_LITE)
+		find_package(variant-lite REQUIRED)
+	ENDIF()
 
 	# ------------------------------------------------------------------------------
 
@@ -133,11 +169,16 @@
 
 	# ------------------------------------------------------------------------------
 	# SObjectizer
-	IF (RESTINIO_ALLOW_SOBJECTIZER)
-		SET(SOBJECTIZER_BUILD_STATIC ON)
+	IF (RESTINIO_SOBJECTIZER_ENABLED)
+		IF (RESTINIO_USE_EXTERNAL_SOBJECTIZER)
+			find_package(sobjectizer)
+		ELSE ()
+			SET(SOBJECTIZER_BUILD_STATIC ON)
+			add_subdirectory(so_5)
+		ENDIF ()
 		SET(SOBJECTIZER_LIBS sobjectizer::StaticLib)
-		add_subdirectory(so_5)
-	ENDIF ()
+	ENDIF()
+
 
 	# ------------------------------------------------------------------------------
 	# Zlib

## restinio 0.6.16

=== dev/CMakeLists.txt ===
--- 
+++ 
@@ -93,8 +93,6 @@
 			find_package(Catch2 CONFIG REQUIRED)
 		ENDIF ()
 
-		include_directories("${CMAKE_SOURCE_DIR}/clara")
-
 		# HTTP parser
 		IF (RESTINIO_USE_EXTERNAL_HTTP_PARSER)
 			find_package(http-parser REQUIRED)

=== dev/so_5/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if((NOT SOBJECTIZER_BUILD_STATIC) AND (NOT SOBJECTIZER_BUILD_SHARED))
  set(SOBJECTIZER_BUILD_STATIC ON)
  set(SOBJECTIZER_BUILD_SHARED ON)
endif()

include(cmake/target.cmake)

set(PTHREDS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

project(sobjectizer)

set(SO_5_DEFS "-DSO_5_PRJ")

if(WIN32)
	list(APPEND SO_5_DEFS "-DSO_5__PLATFORM_REQUIRES_CDECL")
endif()

get_filename_component(CURRENT_FILE_DIR ${CMAKE_CURRENT_LIST_FILE} DIRECTORY)
get_filename_component(CURRENT_FILE_DIR ${CURRENT_FILE_DIR} DIRECTORY)
set(SO_5_INCLUDE_PATH ${CURRENT_FILE_DIR})
unset(CURRENT_FILE_DIR)

set(SO_5_SRC exception.cpp
	exception.cpp
	current_thread_id.cpp
	error_logger.cpp
	timers.cpp
	msg_tracing.cpp
	wrapped_env.cpp
	rt/message.cpp
	rt/enveloped_msg.cpp
	rt/handler_makers.cpp
	rt/message_limit.cpp
	rt/event_queue_hook.cpp
	rt/mbox.cpp
	rt/mchain.cpp
	rt/event_exception_logger.cpp
	rt/agent.cpp
	rt/agent_coop.cpp
	rt/agent_coop_notifications.cpp
	rt/queue_locks_defaults_manager.cpp
	rt/environment.cpp
	rt/disp.cpp
	rt/disp_binder.cpp
	rt/so_layer.cpp

	rt/impl/msg_tracing_helpers.cpp
	rt/impl/subscription_storage_iface.cpp
	rt/impl/subscr_storage_vector_based.cpp
	rt/impl/subscr_storage_map_based.cpp
	rt/impl/subscr_storage_hash_table_based.cpp
	rt/impl/subscr_storage_adaptive.cpp
	rt/impl/process_unhandled_exception.cpp
	rt/impl/named_local_mbox.cpp
	rt/impl/mbox_core.cpp
	rt/impl/coop_repository_basis.cpp
	rt/impl/disp_repository.cpp
	rt/impl/layer_core.cpp
	rt/impl/state_listener_controller.cpp
	rt/impl/mt_env_infrastructure.cpp
	rt/impl/simple_mtsafe_st_env_infrastructure.cpp
	rt/impl/simple_not_mtsafe_st_env_infrastructure.cpp
	
	rt/stats/repository.cpp
	rt/stats/std_names.cpp

	rt/stats/impl/std_controller.cpp
	rt/stats/impl/ds_agent_core_stats.cpp
	rt/stats/impl/ds_mbox_core_stats.cpp
	rt/stats/impl/ds_timer_thread_stats.cpp
	
	disp/mpsc_queue_traits/pub.cpp
	disp/mpmc_queue_traits/pub.cpp
	disp/one_thread/pub.cpp
	disp/active_obj/pub.cpp
	disp/active_group/pub.cpp
	disp/thread_pool/pub.cpp
	disp/adv_thread_pool/pub.cpp
	disp/prio_one_thread/strictly_ordered/pub.cpp
	disp/prio_one_thread/quoted_round_robin/pub.cpp
	disp/prio_dedicated_threads/one_per_prio/pub.cpp

	experimental/testing/v1/all.cpp
)

function(setup_target_cxx_std TARGET_NAME)
	if(${CMAKE_VERSION} VERSION_LESS "3.8.0")
		set_target_properties(${TARGET_NAME} PROPERTIES
			CXX_STANDARD 11
			CXX_STANDARD_REQUIRED YES
			CXX_EXTENSIONS NO
		)
	else()
		target_compile_features(${TARGET_NAME} PUBLIC cxx_std_11)
	endif()
endfunction()

set(SO_5_TARGETS_TO_INSTALL)

if(SOBJECTIZER_BUILD_SHARED)
	add_library(${SO_5_SHARED_LIB} SHARED ${SO_5_SRC})
	add_library(sobjectizer::SharedLib ALIAS ${SO_5_SHARED_LIB})
	set_property(TARGET ${SO_5_SHARED_LIB} PROPERTY EXPORT_NAME SharedLib)
	setup_target_cxx_std(${SO_5_SHARED_LIB})

	if(NOT WIN32)
		target_compile_options(${SO_5_SHARED_LIB}
			PRIVATE -fvisibility=hidden -fvisibility-inlines-hidden
		)
	endif()

	target_compile_definitions(${SO_5_SHARED_LIB}
		PRIVATE ${SO_5_DEFS}
	)
	target_include_directories(${SO_5_SHARED_LIB}
		PUBLIC
			$<BUILD_INTERFACE:${SO_5_INCLUDE_PATH}>
			$<INSTALL_INTERFACE:include>
	)
	target_link_libraries(${SO_5_SHARED_LIB} ${CMAKE_THREAD_LIBS_INIT})

	set(SO_5_EXT_LIBS )
	if( ANDROID )
		list(APPEND SO_5_EXT_LIBS ${ANDROID_LIBCRYSTAX_FILE})
		list(APPEND SO_5_EXT_LIBS ${ANDROID_LIBSTDCXX_FILE})
	endif()

	foreach(__extLibrary ${SO_5_EXT_LIBS})
		add_custom_command(TARGET ${SO_5_SHARED_LIB} PRE_LINK
			COMMAND ${CMAKE_COMMAND} -E copy_if_different ${__extLibrary} $<TARGET_FILE_DIR:${SO_5_SHARED_LIB}>)
	endforeach()

	list(APPEND SO_5_TARGETS_TO_INSTALL ${SO_5_SHARED_LIB})
endif()

if(SOBJECTIZER_BUILD_STATIC)
	add_library(${SO_5_STATIC_LIB} STATIC ${SO_5_SRC})
	add_library(sobjectizer::StaticLib ALIAS ${SO_5_STATIC_LIB})
	set_property(TARGET ${SO_5_STATIC_LIB} PROPERTY EXPORT_NAME StaticLib)
	setup_target_cxx_std(${SO_5_STATIC_LIB})
	target_compile_definitions(${SO_5_STATIC_LIB}
		PRIVATE ${SO_5_DEFS}
	)
	target_compile_definitions(${SO_5_STATIC_LIB}
		PUBLIC -DSO_5_STATIC_LIB
	)
	target_include_directories(${SO_5_STATIC_LIB}
		PUBLIC
			$<BUILD_INTERFACE:${SO_5_INCLUDE_PATH}>
			$<INSTALL_INTERFACE:include>
	)
	target_link_libraries(${SO_5_STATIC_LIB} ${CMAKE_THREAD_LIBS_INIT})

	list(APPEND SO_5_TARGETS_TO_INSTALL ${SO_5_STATIC_LIB})
endif()

if(SOBJECTIZER_INSTALL)
	set(SO_5_CMAKE_FILES_DEST "lib/cmake/sobjectizer")

	install(
		TARGETS ${SO_5_TARGETS_TO_INSTALL}
		EXPORT SO_5_ALL_TARGETS
		LIBRARY DESTINATION lib
		ARCHIVE DESTINATION lib
		RUNTIME DESTINATION bin
	)
	install(
		EXPORT SO_5_ALL_TARGETS
		FILE sobjectizer-targets.cmake
		NAMESPACE sobjectizer::
		DESTINATION ${SO_5_CMAKE_FILES_DEST}
	)

	if(SOBJECTIZER_BUILD_SHARED)
		foreach(__extLibrary ${SO_5_EXT_LIBS})
			install(FILES ${__extLibrary} DESTINATION lib)
		endforeach()
	endif()

	file(GLOB_RECURSE ALL_SO_5_HEADERS RELATIVE ${CMAKE_CURRENT_LIST_DIR} *.hpp)

	foreach( HEADER_FILE ${ALL_SO_5_HEADERS} )
		if(NOT HEADER_FILE MATCHES "[\\/]impl[\\/]")
			get_filename_component( DIR ${HEADER_FILE} PATH )
			install( FILES ${HEADER_FILE} DESTINATION include/so_5/${DIR} )
		endif()
	endforeach()

	set(SO_5_CONFIG_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/sobjectizer-config-version.cmake")
	set(SO_5_CONFIG_FILE "${CMAKE_CURRENT_BINARY_DIR}/sobjectizer-config.cmake")

	include(CMakePackageConfigHelpers)
	write_basic_package_version_file(
		${SO_5_CONFIG_VERSION_FILE}
		VERSION ${SO_5_VERSION}
		COMPATIBILITY ExactVersion 
	)
	configure_package_config_file(
		"cmake/sobjectizer-config.cmake.in"
		${SO_5_CONFIG_FILE}
		INSTALL_DESTINATION ${SO_5_CMAKE_FILES_DEST}
		PATH_VARS SO_5_VERSION
	)

	install(
		FILES ${SO_5_CONFIG_FILE} ${SO_5_CONFIG_VERSION_FILE}
		DESTINATION ${SO_5_CMAKE_FILES_DEST}
	)
endif()

=== debian/changelog ===
restinio (0.6.16-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop Build-Depends: libpcre++-dev. (Closes: #1020932)
  * Replace default CI config with central one.

  [ Bo YU ]
  * Fix FTBFS on riscv64. (Closes: #1019723)

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.5.1, no changes needed.

 -- Bastian Germann <bage@debian.org>  Thu, 29 Sep 2022 15:20:35 +0200

restinio (0.6.16-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release.
    - Fixes FTBFS with fmtlib 9. (Closes: #1014546)
    - catch2 updated to compile with glibc 2.34. (Closes: #1017149)
    - Drop 0001-INTERFACE-fmt-fmt.patch applied upstream.

 -- Adrian Bunk <bunk@debian.org>  Mon, 29 Aug 2022 01:53:03 +0300

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,16 @@
 Maintainer: Felix Salfelder <felix@salfelder.org>
 Build-Depends: catch2,
                cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libasio-dev,
                libboost-dev,
                libboost-regex-dev,
                libfmt-dev,
                libhttp-parser-dev,
-               libpcre++-dev,
                libpcre2-dev,
                libssl-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Section: libs
 Homepage: https://github.com/Stiffstream/restinio
 Vcs-Browser: https://salsa.debian.org/debian/restinio

## restinio 0.6.19

=== debian/changelog ===
restinio (0.6.19-1) unstable; urgency=medium

  * New upstream release
    - Drop upstreamed patch for fixing FBTFS with GCC 13.
  * Fix debian/watch file to correctly find upstream releases
  * Update debian/upstream/metadata
  * Switch debian/patches/ to {0xxx,1xxx,2xxx} naming convention
  * Update debian/copyright to address lintian warnings

 -- Amin Bandali <bandali@gnu.org>  Sat, 02 Sep 2023 16:49:01 -0400

restinio (0.6.16-1) unstable; urgency=medium

  * Fix FTBFS with GCC-13 (Closes: #1037841)
  * debian/control: Taking over the maintenance of the package; many
    thanks, Felix!
  * Update standards version to 4.6.2, no changes needed

 -- Amin Bandali <bandali@gnu.org>  Mon, 14 Aug 2023 20:00:33 -0400

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: restinio
 Priority: optional
-Maintainer: Felix Salfelder <felix@salfelder.org>
+Maintainer: Amin Bandali <bandali@gnu.org>
+Uploaders: Felix Salfelder <felix@salfelder.org>
 Build-Depends: catch2,
                cmake,
                debhelper-compat (= 13),
@@ -12,7 +13,7 @@
                libpcre2-dev,
                libssl-dev,
                zlib1g-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/Stiffstream/restinio
 Vcs-Browser: https://salsa.debian.org/debian/restinio

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%" \
https://api.github.com/repos/Stiffstream/restinio/releases?per_page=50 \
https://github.com/[^/]+/[^/]+/releases/download/[^/]+/restinio-@ANY_VERSION@-full\.tar\.bz2

## restinio 0.6.19+ds

=== dev/test/CMakeLists.txt ===
project(tests)

add_subdirectory(catch_main)
add_subdirectory(metaprogramming)
add_subdirectory(tuple_algorithms)

add_subdirectory(utf8_checker)

add_subdirectory(http_field_parser)
add_subdirectory(try_parse_field)
add_subdirectory(multipart_body)
add_subdirectory(default_constructed_settings)
add_subdirectory(ref_qualifiers_settings)
add_subdirectory(header)
add_subdirectory(buffers)
add_subdirectory(response_coordinator)
add_subdirectory(write_group_output_ctx)
add_subdirectory(uri_helpers)
add_subdirectory(socket_options)
add_subdirectory(start_stop)
add_subdirectory(handle_requests)
add_subdirectory(run_on_thread_pool)
add_subdirectory(http_pipelining)
add_subdirectory(sendfile)
add_subdirectory(router)
add_subdirectory(transforms/zlib)
add_subdirectory(transforms/zlib_body_appender)
add_subdirectory(transforms/zlib_body_handler)
add_subdirectory(encoders)
add_subdirectory(from_string)
add_subdirectory(websocket)
add_subdirectory(file_upload)
add_subdirectory(basic_auth)
add_subdirectory(bearer_auth)

if ( OPENSSL_FOUND )
	add_subdirectory(socket_options_tls)
endif ()

=== dev/sample/notificators/CMakeLists.txt ===
set(SAMPLE sample.notificators)
include(${CMAKE_SOURCE_DIR}/cmake/sample.cmake)

TARGET_LINK_LIBRARIES(${SAMPLE} PRIVATE ${SOBJECTIZER_LIBS})

=== dev/sample/sendfiles/CMakeLists.txt ===
set(SAMPLE sample.sendfiles)
include(${CMAKE_SOURCE_DIR}/cmake/sample.cmake)

=== dev/sample/websocket_detailed/CMakeLists.txt ===
set(SAMPLE sample.websocket_detailed)
include(${CMAKE_SOURCE_DIR}/cmake/sample.cmake)

=== dev/test/from_string/CMakeLists.txt ===
set(UNITTEST _unit.test.from_string)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== dev/test/handle_requests/CMakeLists.txt ===
add_subdirectory(method)
add_subdirectory(echo_body)
add_subdirectory(timeouts)
add_subdirectory(throw_exception)
add_subdirectory(slow_transmit)
add_subdirectory(user_controlled_output)
add_subdirectory(chunked_output)
add_subdirectory(output_and_buffers)
add_subdirectory(notificators)
add_subdirectory(remote_endpoint)
add_subdirectory(connection_state)
add_subdirectory(ip_blocker)

add_subdirectory(upgrade)

add_subdirectory(chunked_input)

add_subdirectory(acceptor_post_bind_hook)

add_subdirectory(incoming_msg_limits)

add_subdirectory(connection_count_limit)

add_subdirectory(user_data_simple)

add_subdirectory(chained_handlers)

=== dev/test/response_coordinator/CMakeLists.txt ===
set(UNITTEST _unit.test.response_coordinator)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== dev/test/socket_options_tls/CMakeLists.txt ===
set(UNITTEST _unit.test.socket_options_tls)

include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

TARGET_INCLUDE_DIRECTORIES(${UNITTEST} PRIVATE ${OPENSSL_INCLUDE_DIR})
TARGET_LINK_LIBRARIES(${UNITTEST} PRIVATE ${OPENSSL_LIBRARIES})

=== dev/test/start_stop/CMakeLists.txt ===
set(UNITTEST _unit.test.start_stop)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== dev/test/utf8_checker/CMakeLists.txt ===
set(UNITTEST _unit.test.utf8_checker)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== dev/test/write_group_output_ctx/CMakeLists.txt ===
set(UNITTEST _unit.test.write_group_output_ctx)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== dev/test/handle_requests/chunked_output/CMakeLists.txt ===
set(UNITTEST _unit.test.handle_requests.chunked_output)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)

=== debian/changelog ===
restinio (0.6.19+ds-1) unstable; urgency=medium

  * Repack to remove several embedded copies, per #1053931.
  * debian/control: Add rapidjson-dev to Build-Depends.
  * debian/copyright: Remove entries corresponding to the
    removed embedded copies.
  * debian/watch: Add compression=bzip2, dversionmangle=auto,
    and repacksuffix=+ds.

 -- Amin Bandali <bandali@gnu.org>  Thu, 26 Oct 2023 01:00:31 -0400

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
-ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc sh4))
+ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc riscv64 sh4))
 	export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
 endif

=== debian/watch ===
version=4
opts="searchmode=plain,compression=bzip2,dversionmangle=auto,\
repacksuffix=+ds,filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%" \
https://api.github.com/repos/Stiffstream/restinio/releases?per_page=50 \
https://github.com/[^/]+/[^/]+/releases/download/[^/]+/restinio-@ANY_VERSION@-full\.tar\.bz2

## restinio 0.6.19+ds-1+11.0trisquel1

=== debian/changelog ===
restinio (0.6.19+ds-1+11.0trisquel1) aramo-backports; urgency=medium

  * Imported into trisquel backports as part of jami dependency.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 31 Oct 2023 11:37:43 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: restinio
 Priority: optional
-Maintainer: Amin Bandali <bandali@gnu.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders: Felix Salfelder <felix@salfelder.org>
 Build-Depends: catch2,
                cmake,
@@ -12,6 +12,7 @@
                libhttp-parser-dev,
                libpcre2-dev,
                libssl-dev,
+               rapidjson-dev,
                zlib1g-dev
 Standards-Version: 4.6.2
 Section: libs
